<?php
/**
 * @file
 * Contains \Drupal\facebook_comments\EnablerService
 */

namespace Drupal\facebook_comments;

use Drupal\Core\Database\Database;
use Drupal\Node\Entity\Node;

/**
 * Defines a service for managing Facebook comments enabled for nodes.
 */
class EnablerService {
  /**
   * Constructor
   */
  public function __contruct() {
  	
  }

  /**
   * Sets a individual node to be Facebook comments enabled.
   *
   * @param \Drupal\node\Entity\Node $node
   */
  public function setEnabled(Node $node, $enabled = 1, $amount = 15) {
  	$cenabled = $this->isEnabled($node);
  	if (empty($cenabled)) {
      $insert = Database::getConnection()->insert('facebook_comments');
      $insert->fields(array('nid' => $node->id(), 'enabled' => $enabled, 'amount' => $amount));
      $insert->execute();
    }
    else {
      $update = Database::getConnection()->update('facebook_comments');
      $update->fields(array('enabled' => $enabled, 'amount' => $amount));
      $update->condition('nid', $node->id());
      $update->execute();    	
    }
  }

  /**
   * Checks if an individual node is Facebook comments enabled.
   *
   * @param \Drupal\node\Entity\Node $node
   *
   * @return bool
   *  Whether the node is enabled for the Facebook comments functionality.
   */
  public function isEnabled(Node $node) {
    if ($node->isNew()) {
      return FALSE;
    }
    $select = Database::getConnection()->select('facebook_comments', 'fb');
    $select->fields('fb', array('enabled', 'amount'));
    $select->condition('nid', $node->id());
    $results = $select->execute();
    return $results->fetchAll();
  }
}
